// ROUTES FOR OUR API
// =============================================================================
var express = require('express');
var bcrypt = require('bcryptjs');
var router = express.Router(); // get an instance of the express Router
const querystring = require('querystring');
var mysql = require('./mysql');
const _mysqlLabor = ["10.3.16.226", "ssti_cm"]; //本地双创數據庫信息
// const _mysqlLabor = ["127.0.0.1", "ssti_cm"]; //本地双创數據庫信息
// const _mysqlLabor = ["172.16.12.5", "pbl"]; //双创數據庫信息
var crypto = require('crypto');
var https = require('https');

//統壹處理區域
router.use(async function(req, res, next) {
    await asynnext(req, res, next);
    //// make sure we go to the next routes and don't stop here
    //res.end("");
});

/**
 * @des 參數解釋同上
 */
function asynnext(req, res, next) {
    //異步處理
    return new Promise(async(resolve, reject) => {
        next();
        //resolve(true);aa
    });
}
/*測試*/
router.route('/a').all((req, res, next) => {
    var json = GetData(req);
    getmysql(req, res, "a");
});

//qgt 查看数据库是否有此人
// router.use((req,res,next)=>{
//     const uid = GetData(req)['uid'];
//     let p = [_mysqlLabor[0], _mysqlLabor[1], 'select_UserByUserId',uid];
//     mysql.usselect(p,function(result){
//         if(result[0].length==1){
//             next();
//         }else{
//             res.Back(1,"用户不存在",GetData(req))
//         }
//     })
// })

//qgt 新增全站通知
router.post("/CreateNewNotification",(req,res)=>{
    QMysql(req,res,"insert_New")
})

//qgt 获取全站通知
router.get('/SelectNotification',(req,res)=>{
    QMysql(req,res,'select_NewByTitle')
})

//qgt 删除通知
router.post("/DeleteNotification",(req,res)=>{
    QMysql(req,res,"update_NewStatusById");
})

//qgt 获取消息通知详细
router.get("/SelectNotificationDetail",(req,res)=>{
    QMysql(req,res,"select_NewDetailById");
})

//qgt 获取所有的学院
router.get("/SelectAllDepartment",(req,res)=>{
    QMysql(req,res,"select_AllDepartment");
})

//qgt 获取所有的分类
router.get("/SelectAllType",(req,res)=>{
    QMysql(req,res,"select_AllType")
})

//qgt 添加项目申请
router.post("/CreateProject",(req,res)=>{
    QMysql(req,res,"insert_project");
})

//qgt 项目立项申请获取数据
router.get("/SelectAllProject",(req,res)=>{
    QMysql(req,res,"select_AllProject");
})

//qgt 获取立项申请的基础信息
router.get('/GetProjectBase',(req,res)=>{
    QMysql(req,res,"select_ProjectBaseById");
})

//qgt 获取项目详细信息
router.get('/GetProjectDetailMessage',(req,res)=>{
    QMysql(req,res,"select_ProjectMessageById")
})

//qgt 删除项目详细信息
router.post('/DeleteProject',(req,res)=>{
    const data = GetData(req);
    mysql.usselect([_mysqlLabor[0], _mysqlLabor[1],'update_ProjectDeleteById',data['uid'],data['pid'],1],result=>res.end(JSON.stringify(result)));
})

//qgt 项目立项申请提交审核
router.post("/ApproveProject",(req,res)=>{
    const data = GetData(req);
    mysql.usselect([_mysqlLabor[0], _mysqlLabor[1],'update_ProjectIsupload',data['uid'],data['pid'],1],result=>res.end(JSON.stringify(result)));
})

//qgt 修改项目立项申请基础信息
router.post('/UpdateProjectBase',(req,res)=>{
    QMysql(req,res,"update_ProjectBase");
})

//qgt 修改项目立项申请详细信息
router.post("/UpdateProjectDetail",(req,res)=>{
    QMysql(req,res,'update_ProjectDetail');
})

//qgt 获取所有项目名称和ID
router.get("/GetAllProjectName",(req,res)=>{
    QMysql(req,res,'select_AllProjectName');
})

//qgt 创建创客活动
router.post('/CreateActivity',(req,res)=>{
    QMysql(req,res,"insert_Activity")
})

//qgt 获取所有的创客活动
router.get('/GetAllActivity',(req,res)=>{
    QMysql(req,res,"select_AllActivity")
})

//qgt 获取创客活动详细
router.get("/GetActivityDetail",(req,res)=>{
    QMysql(req,res,"select_ActivityDetail");
})

//qgt 修改活动管理
router.post("/UpdateActivity",(req,res)=>{
    QMysql(req,res,"update_Activity");
})

//qgt 修改活动管理状态
router.post("/UpdateActivityState",(req,res)=>{
    QMysql(req,res,"update_ActivityState");
})

//qgt 活动管理上传报告
router.post("/UploadActivityFile",(req,res)=>{
    QMysql(req,res,"update_ActivityReportFile")
})

//yym 项目管理结项上传报告
router.post("/UploadProjectManageFile",(req,res)=>{
    QMysql(req,res,"update_ProjectManageFile")
})
//yym 项目管理-进度详情-项目结题附件-获取项目结题附件
router.get("/SelectProjectManageFile",(req,res)=>{
    QMysql(req,res,"select_ProjectManageFile")
})

//yym 项目管理-进度详情-项目附件-上传项目附件
router.post("/AddProjectFile",(req,res)=>{
    QMysql(req,res,"update_ProjectFile")
})

//yym 项目管理-进度详情-项目附件-获取项目附件
router.get("/SelectProjectFile",(req,res)=>{
    QMysql(req,res,"select_ProjectFile")
})


//yym 项目管理-进度详情-项目结题附件-上传项目结题附件
router.post("/AddProjectManageFile",(req,res)=>{
    QMysql(req,res,"update_EndProjectFile")
})

// yym 项目结项-获取项目结项首页渲染数据
router.get("/SelectSettlement",(req,res)=>{
    QMysql(req,res,"select_Settlement")
})

// yym 项目结项-确定完结项目
router.post("/UpdateSettlementIsUpload",(req,res)=>{
    QMysql(req,res,"update_SettlementIsUpload")
})


//qgt 通过项目ID获取所有的活动附件
router.get("/GetActivityFileByProjectId",(req,res)=>{
    QMysql(req,res,"select_AllActivityFileByProjectId")
})

//qgt 创业公司上传文件
router.post("/UploadFirmFile",(req,res)=>{
    QMysql(req,res,"insert_startups")
})

//qgt 获取创业公司上传的文件
router.get("/GetFirmFile",(req,res)=>{
    QMysql(req,res,"select_startupsByTitle");
})

//qgt 修改创业公司文件的状态
router.post("/UpdateFirmFileState",(req,res)=>{
    QMysql(req,res,"update_startupsState");
})

//qgt 获取已经结项的
router.get("/GetProjectIsEndProject",(req,res)=>{
    QMysql(req,res,"select_ProjectIsEndProject");
})

//qgt 通过ID获取已经结项项目的数据
router.get("/GetProjectEndByID",(req,res)=>{
    QMysql(req,res,"select_ProjectEndBaseById")
})

//qgt 通过ID修改学生学分
router.post("/UpdateStudentScore",(req,res)=>{
    QMysql(req,res,"update_ProjectStudentScore");
})

//qgt 获取项目下所有活动的预算
router.get('/GetAllActivityMoneyByProjectId',(req,res)=>{
    QMysql(req,res,"select_ActivityAllMoneyByProjectId")
})

GetData = function(req) {
    var a = req.url.split("?");
    var json = querystring.parse(a[1])
    if(Object.keys(json).length!=0){
        return json
    }else if(req.body){
        return req.body
    }else if(req.body.mode){
        return req.body.mode;
    }
}

//存储过程处理
QMysql = function(req,res,functionName){
    if (GetData(req)) {
        p = Object.values(GetData(req));
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionName);
        //執行存儲過程
        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
    }else{
        res.end("未获取参数")
    }
}

//post存儲過程處理
// PostMysql = function(req, res, functionName) {
//     //mode的處理
//     if (GetData(req)) {
//         p = Object.values(GetData(req));
//         p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionName);
//         //執行存儲過程
//         mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
//     }else{
//         res.end("未获取参数")
//     }
// }

// GetMysql = function(req,res,functionName){
//     if(GetData(req)){
//         p = Object.values(GetData(req));
//         p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionName);
//         mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });

//     }else{
//         res.end("未获取参数")
//     }
// }


//post存儲過程處理
// postmysql = function(req, res, functionname) {
//     //mode的處理
//     if (req.body[0]) {
//         p = Object.values(req.body[0]);
//         p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
//         //執行存儲過程
//         mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
//     }
// }

//post存儲過程處理
postmysql2 = function(req, res, functionname) {
    //mode的處理
    if (req.body) {
        p = Object.values(req.body)[0].split(",");
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
        //執行存儲過程
        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
    }
}

// router.route('/selectStudentCourseDetail').all((req, res, next) => { //学生
//     var json = queryString(req.url);
//      getmysql(req, res, "selectStudentCourseDetail", json['courseId']);
//     });
//     router.route('/addWorks').all((req, res, next) => {
//      postmysql(req, res, "add_works");
//     });

//post存儲過程處理
postmysql3 = function(req, res, functionname) {
    //mode的處理
    if (req.body) {
        p = Object.values(req.body);
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
        //執行存儲過程
        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
    }
}

//get獲取數據庫信息
getmysql = function(req, res, functionname, ...p) {
    p = p || [];
    p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
    //執行存儲過程
    mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); }); //
}


//post存储过程处理

userpostmysql = function(req, res, functionname) {

    //mode的处理

    if (req.body.mode) {

        p = req.body.mode.split(",");

        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);

        //执行存储过程

        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });

    }

}



//get获取数据库信息

usergetmysql = function(req, res, functionname, ...p) {

    p = p || [];

    p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);

    //执行存储过程

    mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); }); //
}


// //获取请求数据
// function GetData(req){
//     if(req.body['uid']==null){
//         return req.query
//     }else{
//         return req.body
//     }

    
//     // return req.query | req.body;

//     // if(req.method =='POST'){
//         // return req.body;
//     // }else if(req.method =="GET"){
//         // return req.query;
//     // }
// }   


//获取当前时间
// function getNowDate() {
//     let date = new Date();
//     let year = date.getFullYear(); //年
//     let month = date.getMonth() + 1; //月
//     let day = date.getDate(); //日
//     let hour = date.getHours(); //时
//     let minutes = date.getMinutes(); //分
//     let seconds = date.getSeconds(); //秒
//     if (month > 1 && month <= 9) month = "0" + month;
//     if (day > 0 && day <= 9) day = "0" + day;
//     if (hour > 0 && hour < 9) hour = "0" + hour;
//     if (minutes > 0 && minutes <= 9) minutes = "0" + minutes;
//     if (seconds > 0 && seconds < 9) seconds = "0" + seconds;
//     return `${year}-${month}-${day} ${hour}:${minutes}:${seconds}`;
// }

module.exports = router;